from PyQt6.QtCore import QThread, pyqtSignal


class LoadEndpointsWorker(QThread):
    endpoints_retrieved = pyqtSignal(list)
    error_occurred = pyqtSignal(str)

    def __init__(self, portainer):
        super().__init__()
        self.portainer = portainer

    def run(self):
        try:
            endpoints = self.portainer.endpoints.list_endpoints()
            self.endpoints_retrieved.emit(endpoints)
        except Exception as e:
            self.error_occurred.emit(str(e))